/*  assert.h

    assert macro

*/

void __assertfail( char *__msg,
          char *__cond,
          char *__file,
          int __line);

#undef assert
#ifndef NDEBUG
#define assert(p) ((p) ? (void)0 : (void) __assertfail( \
                    "Assertion failed: %s, file %s, line %d\n", \
                    #p, __FILE__, __LINE__ ) )
#else
#define assert(p) ((void)0)